/// <reference types="node" />
import { Api } from '@openstapps/gitlab-api';
import { Group, Project } from '@openstapps/gitlab-api/lib/types';
import { Logger } from '@openstapps/logger';
import { readFile, unlink, writeFile } from 'fs';
import * as glob from 'glob';
export declare const readFilePromisified: typeof readFile.__promisify__;
export declare const globPromisified: typeof glob.__promisify__;
export declare const writeFilePromisified: typeof writeFile.__promisify__;
export declare const unlinkPromisified: typeof unlink.__promisify__;
export declare const logger: Logger;
/**
 * Get projects for a list of groups
 *
 * @param api GitLab API to make requests with
 * @param groups List of groups
 */
export declare function getProjects(api: Api, groups: number[]): Promise<Project[]>;
/**
 * Get subgroups for a list of groups
 *
 * @param api GitLab API to make requests with
 * @param groups List of groups
 */
export declare function getSubGroups(api: Api, groups: number[]): Promise<Group[]>;
/**
 * Flatten 2d array
 *
 * @param arr Flattened array
 */
export declare function flatten2dArray<T>(arr: T[][]): T[];
